<template>
    <div>
        <div class="row">
            <div class="col-md-12">
                <div class="form-group" style="margin-top: 25px;">
                    <label class="control-label">Choose Item Type</label>
                    <div class="radio-list">
                        <label class="radio-inline p-0">
                            <div class="radio radio-info">
                                <input type="radio" name="demand_type" id="radio1" value="1" v-model="itemType" v-on:change="searchItem">
                                <label for="radio1">Product</label>
                            </div>
                        </label>
                        <label class="radio-inline">
                            <div class="radio radio-info">
                                <input type="radio" name="demand_type" id="radio2" value="2" v-model="itemType" v-on:change="searchItem">
                                <label for="radio2">Product Set</label>
                            </div>
                        </label>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-4">
                <h3 class="bg-warning p-10">ITEM LIST</h3>
                <div class="form-group">
                    <input type="text" class="form-control" placeholder="Search Product" v-model="searchedText" v-on:keyup="searchItem">
                </div>
                <table class="table table-bordered">
                    <tbody>
                    <tr v-if="itemCollections.length" v-for="(product,index) in itemCollections">
                        <td v-on:click="selectProduct(index)" v-if="index < 10">{{ product.name }}</td>
                    </tr>
                    </tbody>
                </table>
            </div>

            <div class="col-md-8">
                <h3 class="bg-info p-10">SELECTED ITEM LIST</h3>
                <table class="table table-bordered">
                    <thead>
                    <tr class="primary">
                        <th colspan="3">SELECTED PRODUCT LIST</th>
                    </tr>
                    <tr>
                        <th>Product Name</th>
                        <th>Unit</th>
                        <th>Qty</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-if="setProducts.length" v-for="(product,index) in setProducts">
                        <td v-on:click="deSelectProduct(index)">
                            <input type="hidden" :name="'product['+ index +'][id]'" v-model="setProducts[index].id">
                            <input type="hidden" :name="'product['+ index +'][type]'" v-model="setProducts[index].item_type">
                            {{ product.name }}
                        </td>
                        <td>
                            <select :name="'product['+ index +'][unit]'" class="form-control table-input" v-model="setProducts[index].unitId" required>
                                <option value="">--Select--</option>
                                <option v-for="unit in units" :value="unit.id">{{ unit.name }}</option>
                            </select>
                        </td>
                        <td style="width: 100px">
                            <input type="number" :name="'product['+ index +'][quantity]'" class="form-control table-input" v-model="setProducts[index].quantity" required>
                        </td>
                    </tr>
                    </tbody>
                </table>

            </div>
        </div>
    </div>
</template>

<script>

    export default {
        props: ['items'],

        data: function() {

            return {
                products: [],
                setProducts: [],
                requisitionProducts: [],
                units: [],
                itemType: 1,
                itemCollections: [],
                searchedText: ""
            };
        },

        methods: {
            selectProduct: function (index) {
                let item = {};

                if(this.itemType == 1){
                    item = this.products[index];
                    this.products.splice(index,1);
                }else{
                    item = this.productSets[index];
                    this.productSets.splice(index,1);
                }

                item.unitId = "";
                item.quantity = "";
                this.setProducts.push(item);

            },
            deSelectProduct: function (index) {
                let item = this.setProducts[index];

                delete item.unitId;
                delete item.quantity;
                if(item.item_type == 1){
                    this.products.push(item);
                }else{
                    this.productSets.push(item);
                }
                this.setProducts.splice(index,1);
            },
            searchItem: function () {
                this.itemCollections = [];
                if(this.itemType == 1){
                    if(this.searchedText.length){
                        this.itemCollections = this.products.filter((item) => {
                            return item.name.toUpperCase().search(this.searchedText.toUpperCase()) != -1;
                        });
                    }else{
                        this.itemCollections = this.products;
                    }
                }else{
                    if(this.searchedText.length){
                        this.itemCollections = this.productSets.filter((item) => {
                            return item.name.toUpperCase().search(this.searchedText.toUpperCase()) != -1;
                        });
                    }else{
                        this.itemCollections = this.productSets;
                    }
                }
            }

        },
        created: function() {
            this.itemCollections = this.items.products;
            this.products = this.items.products;
            this.productSets = this.items.productSets;
            this.setProducts = this.items.demandProducts;
            this.units = this.items.units;
            console.log(this.setProducts);
        },
        mounted() {

        },


    };
</script>